/**********************************************************/
/*   MAKE ROM IMAGE [GETROM.C]                            */
/*                       Copyright (C) Matsumo 1998,1999  */
/**********************************************************/
#include <stdio.h>
#include <stdlib.h>
#include <string.h>

typedef unsigned char	BYTE;
typedef unsigned short	WORD;


/* -1:error,0:OK */
short decode_data(char *data)
{
	BYTE	w[16],b[16],s;
	short	i,z;
	static long	a=0xc0000;
	printf("%05lX:",a);
	b[2]=0;s=0;
	for(i=0;i<16;i++){
		strncpy(b,&data[6+(i<<1)],2);
		sscanf(b,"%02X",&w[i]);
		s+=w[i]; /*printf("%d:%02x,",i,w[i]);*/
	}
	s+=(a>>16)+(a>>8)+a;
	strncpy(b,&data[39],2);
	sscanf(b,"%02X",&z); /*printf(":%02x,%02x\n",s,z);*/
	if(s!=z){
		printf("check sum error at %05lX.\n",a);
		return(-1);
	}
	if(a==0xffff0) a=0x20000; else a+=0x10;
	memcpy(data,w,16);
/*printf("[%02x,%02x,%02x,%02x]",data[0],data[1],w[0],w[1]);*/
	printf("OK\n");
	return(0);
}

void main(int argc, char *argv[])
{
	char	t[64];
	FILE	*fpi, *fpo;
	long	count=0;
	printf("GETROM Ver.3.0 Copyright(c)1999 matsumo\n");
	if(argc<2){
		printf(" usage:getrom in-file out-file\n");
		exit(1);
	}
	if(((fpi = fopen(argv[1], "r"))!= NULL)&&
	  ((fpo = fopen(argv[2], "wb"))!= NULL)){
		while(fgets(t, 64, fpi)!=NULL){
/*printf("%s\n",t);*/
			if(decode_data(t)!=-1){
				fwrite(t,16,1,fpo);
				count++;
			}else exit(1);
		}
		fclose(fpi); fclose(fpo);
/*		if(count==16384 || count==24576){*/
			printf("done.\n");
/*		}else{
			printf("file size miss match!\n");
		}*/
	}else printf("file not found.\n");
}
